Prime Path
描述:The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
输入:One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
输出:One line for each case, either with a number stating the minimal cost or containing the word Impossible.
思路:基于广搜求最短路径的思想,求起始素数变为终点素数的最少变换次数。这里我想的是从其实状态开始,每次变换四个数字中的一个数字,相当于每次走一步,直到变为目标状态或队列空为止。因为变换中需要频繁使用到四位数的素数,所以我用一个素数表提前储存好所有四位数的素数。每次改变四位数素数中的一个数位上的数字,在广搜中的具体操作就是遍历素数表,若找到与当前队列头的数字有三个位数上的数子相同的元素就将该元素入队,并且将其变换次数修改为队列头的变换次数加1。
// #include <bits/stdc++.h>
#include <iostream>
#include <queue>
#include <vector>
#include <cmath>
using namespace std;
struct myS
{
int n; // 数字数值
int n1; // 千位上的数字
int n2; // 百位上的数字
int n3; // 十位上的数字
int n4; // 个位上的数字
int step; // 变换次数(步数)
};
vector<myS> primeList; // 四位数的素数表
int bfs(int, int); // 广搜
bool isPrime(int); // 判断素数
int sameN(myS, myS); // 查看相同数字位数的个数
int main()
{
for (int i{1009}; i < 10000; i++) { // 初始化素数表
if (isPrime(i)) {
int tmpI;
int tmp[4];
tmpI = i;
for (int j{3}; tmpI; j--, tmpI /= 10) {
tmp[j] = tmpI % 10;
}
primeList.push_back({i, tmp[0], tmp[1], tmp[2], tmp[3], 0});
}
}
int n;
cin >> n;
while (n--) {
int si, ei, cnt;
cin >> si >> ei;
cnt = bfs(si, ei);
if (cnt == -1) {
cout << "Impossible" << endl;
} else {
cout << cnt << endl;
}
}
}
int bfs(int si, int ei)
{
queue<myS> q;
vector<myS> tmpV = primeList; // 因为题目包含多组输入,所以将素数表赋给一个临时变量,防止素数表被破坏
for (int i{}; i < primeList.size(); i++) { // 找起始状态
if (tmpV[i].n == si) { // 找到起始状态
q.push(tmpV[i]); // 将起始状态入队
tmpV[i] = {0, 0, 0, 0, 0, 0}; // 修改将起始状态的值,防止重复搜索
break;
}
}
while (!q.empty()) { // 判断队列是否空
if (q.front().n == ei) { // 若搜索到目标素数
return q.front().step;
}
for (int i{}; i < tmpV.size(); i++) { // 遍历素数表
if (sameN(q.front(), tmpV[i]) == 3) { // 若有三个数位数字相同
tmpV[i].step = q.front().step + 1; // 步数加1
q.push(tmpV[i]);
tmpV[i] = {0, 0, 0, 0, 0, 0}; // 防止重复搜索已到达过的状态
}
}
q.pop(); // 将队列头出队
}
return -1; // 若无法到达目标状态,返回-1
}
bool isPrime(int n)
{
for (int i{2}; i <= sqrt(n); i++) {
if (!(n % i)) {
return false;
}
}
return true;
}
int sameN(myS s1, myS s2)
{
int cnt{};
if (s1.n1 == s2.n1) cnt++;
if (s1.n2 == s2.n2) cnt++;
if (s1.n3 == s2.n3) cnt++;
if (s1.n4 == s2.n4) cnt++;
return cnt;
}